using System;
using System.Collections.Generic;
using System.Text;
using Brume;
using TestBrume.Entities;

namespace TestBrume
{
    class OVNI : Ennemy
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UFO"/> class.
        /// </summary>
        /// <param name="pBrume">The p brume.</param>
        public OVNI(Brume.Brume pBrume , BrumeVector pPosition)
            : base(pBrume)
        {
            

            _model = new BrumeLightedObject(pBrume, "UFOObject");
            _model.Mesh = MeshLoader.GetPreloadedMesh("UFO");
            _model.RenderStates.Lighted = false;
            _model.Size = 0.02f;

            _model.Orient(new BrumeVector(0, -1, 0), new BrumeVector(0, 0, 1));

            _model.Pos = pPosition;
            _fInitialZ = pPosition.Z;

            _model.MoveEvent += new BrumeObjectMoveDelegate(_model_MoveEvent);
        }


        /// <summary>
        /// _model_s the move event.
        /// </summary>
        /// <param name="obj">The obj.</param>
        /// <param name="fElapsedTime">The f elapsed time.</param>
        void _model_MoveEvent(BrumeObject obj, float fElapsedTime)
        {
            float dist = fElapsedTime / 250f;

            _fSinus += dist;

            obj.Pos.X += dist;
            obj.Pos.Z = _fInitialZ + (float)Math.Sin(_fSinus) * 2;

            _fRotation += fElapsedTime / 1000f;

            _model.Orient(new BrumeVector(0, -1, 0), new BrumeVector((float)Math.Sin(_fRotation), 0, (float)Math.Cos(_fRotation)));
        }

        float _fInitialZ;
        float _fSinus = 0f;
        float _fRotation = 0.0f;


    }
}
