using System;
using System.Collections.Generic;
using System.Text;
using Brume;
using TestBrume.Effects;

namespace TestBrume
{
    class BasicShoot : Shoot
    {

        public BasicShoot(Brume.Brume pBrume, BrumeVector pPosition)
            : base(pBrume, "BasicShoot")
        {
            Pos = pPosition;
            _effect = new FireEffect(pBrume, this, new BrumeVector());
            
            this.MoveEvent += new BrumeObjectMoveDelegate(BasicShoot_MoveEvent);
        }

        void BasicShoot_MoveEvent(BrumeObject obj, float fElapsedTime)
        {
            Pos.X -= fElapsedTime / 100f;
            _effect.Update(fElapsedTime);
            
        }


        public override void Remove()
        {
            _effect.Remove();
        }



        FireEffect _effect;

    }
}
