using System;
using System.Collections.Generic;
using System.Text;
using Brume;

namespace TestBrume
{
    class Skybox
    {
        private const int SIZE = 400;


        public Skybox(Brume.Brume brume)
        {
            BrumeSquareTextured down = new BrumeSquareTextured(brume, "down");
            down.RenderStates.Texture[0] = brume.GetTexture("faesky01d.jpg");
            down.Size = SIZE;
            down.Orient(new BrumeVector(0, -1, 0), new BrumeVector(0, 0, -1));
            down.Pos = new BrumeVector(0, -SIZE/2, 0);

            BrumeSquareTextured face = new BrumeSquareTextured(brume, "face");
            face.RenderStates.Texture[0] = brume.GetTexture("faesky01f.jpg");
            face.Size = SIZE;
            face.Orient(new BrumeVector(-1, 0, 0), new BrumeVector(0, 1, 0));
            face.Pos = new BrumeVector(-SIZE/2, 0, 0);

            BrumeSquareTextured right = new BrumeSquareTextured(brume, "right");
            right.RenderStates.Texture[0] = brume.GetTexture("faesky01l.jpg");
            right.Size = SIZE;
            right.Orient(new BrumeVector(0, 0, -1), new BrumeVector(0, 1, 0));
            right.Pos = new BrumeVector(0, 0, -SIZE/2);

            BrumeSquareTextured left = new BrumeSquareTextured(brume, "left");
            left.RenderStates.Texture[0] = brume.GetTexture("faesky01r.jpg");
            left.Size = SIZE;
            left.Orient(new BrumeVector(0, 0, 1), new BrumeVector(0, 1, 0));
            left.Pos = new BrumeVector(0, 0, SIZE/2);

            BrumeSquareTextured back = new BrumeSquareTextured(brume, "back");
            back.RenderStates.Texture[0] = brume.GetTexture("faesky01b.jpg");
            back.Size = SIZE;
            back.Orient(new BrumeVector(1, 0, 0), new BrumeVector(0, 1, 0));
            back.Pos = new BrumeVector(SIZE/2, 0, 0);

            BrumeSquareTextured top = new BrumeSquareTextured(brume, "top");
            top.RenderStates.Texture[0] = brume.GetTexture("faesky01u.jpg");
            top.Size = SIZE;
            top.Orient(new BrumeVector(0, 1, 0), new BrumeVector(-1, 0, 0));
            top.Pos = new BrumeVector(0, SIZE/2, 0);

        }
    }
}
