using System.Drawing;
using Brume;
using TestBrume.Effects;
using System;
using System.Collections.Generic;

namespace TestBrume
{
    /// <summary>
    /// Brume Shoot
    /// </summary>
    class Program : Brume.Brume
    {
        Player _player = null;


        public Program()
            : base()
        {
            this.Text = "ShootInfo";

            //this.InitStates.Mode = BrumeInitParams.MODE_FULLSCREEN;
            this.InitStates.Resolution = BrumeInitParams.RESOLUTION_1280x1024;

            BrumeFileManager.AddDirForAll("Data/Internal");
            BrumeFileManager.AddDirForAll("Data/Meshes");

            
        }

        override protected void GameInit()
        {
            BrumeSquareMeshTextured squareMesh = new BrumeSquareMeshTextured(this, "fire", 0, 0);
            MeshLoader.GetInstance().Initialize(squareMesh);

            BrumeXMesh mesh = new BrumeXMesh(this, "UFO", "mothership.x", false);
            MeshLoader.GetInstance().Initialize(mesh);

            SpaceCamera camera = new SpaceCamera(this, "camera");
            this.SetActiveCamera(camera);

            // buffer clear color setup
            this.BufferClearColor = Color.Black;

            Skybox box = new Skybox(this);
            _player = new Player(this, "MoD");

            OVNI ufo = new OVNI(this,new BrumeVector(-50,0,0));
            OVNI ufo1 = new OVNI(this, new BrumeVector(-40, 0, 7));
            OVNI ufo2 = new OVNI(this, new BrumeVector(-50, 0, -7));


            

       
        }

        protected override void MoveScene(float fElapsedTime)
        {

            

            if (BrumeKeyboard.IsPressed(BrumeKey.RightArrow))
                _player.MoveRight(fElapsedTime);
            else if (BrumeKeyboard.IsPressed(BrumeKey.LeftArrow))
                _player.MoveLeft(fElapsedTime);
            if (BrumeKeyboard.IsPressed(BrumeKey.DownArrow))
                _player.MoveDown(fElapsedTime);
            else if (BrumeKeyboard.IsPressed(BrumeKey.UpArrow))
                _player.MoveUp(fElapsedTime);


            if (BrumeKeyboard.IsPressed(BrumeKey.Space))
                _player.Shoot();

            _player.Update(fElapsedTime);

            ShootsManager.Update(this, fElapsedTime);
            EnnemiesManager.Update(this, fElapsedTime);
          
            // brume call
            base.MoveScene(fElapsedTime);
        }


       


        protected override void AfterRendering()
        {
            base.AfterRendering();

            if (BrumeKeyboard.IsPressed(BrumeKey.Escape))
            {
                this.Close();
                return;
            }
        }

        public static void Main()
        {
            using (Program game = new Program())
            {
                game.Play();
            }
        }
    }
}
