using System;
using System.Collections.Generic;
using System.Text;
using Brume;
using TestBrume.Effects;

namespace TestBrume
{
    class Player
    {
        private const int BORDER_RIGHT = 6  ;
        private const int BORDER_LEFT  = -6 ;
        private const int BORDER_UP    = -10;
        private const int BORDER_DOWN  = 2  ;


        private string _strPseudo;

        public string Pseudo
        {
            get { return _strPseudo; }
            set { _strPseudo = value; }
        }

        public Player(Brume.Brume pBrume, string pPseudo)
        {
            _brume = pBrume;

            BrumeXMesh mesh = new BrumeXMesh(pBrume, "padmesh" + pPseudo, "pad.x", false);


            _shipObject = new BrumeLightedObject(pBrume, "pad" + pPseudo);
            _shipObject.Mesh = mesh;

            _reactorEffect = new FireEffect(pBrume,_shipObject,new BrumeVector(1.5f,0,0));
        }

        public void MoveRight(float pElapsedTime )
        {
            if ( _shipObject.Pos.Z < BORDER_RIGHT)
            _shipObject.Pos.Z += pElapsedTime / _fMoveSpeed;
        }

        public void MoveLeft(float pElapsedTime)
        {
            if (_shipObject.Pos.Z > BORDER_LEFT)
            _shipObject.Pos.Z -= pElapsedTime / _fMoveSpeed;
        }

        public void MoveUp(float pElapsedTime)
        {
            if (_shipObject.Pos.X > BORDER_UP)
            _shipObject.Pos.X -= pElapsedTime / _fMoveSpeed;
        }

        public void MoveDown(float pElapsedTime)
        {
            if (_shipObject.Pos.X < BORDER_DOWN)
            _shipObject.Pos.X += pElapsedTime / _fMoveSpeed;
        }


        public void Update(float pElapsedTime)
        {
            _reactorEffect.Update(pElapsedTime);

            _fShootCoolDown -= pElapsedTime;

        }

        public void Shoot()
        {
            if (_fShootCoolDown > 0)
                return;

            _fShootCoolDown = 800f;
            BasicShoot shoot = new BasicShoot(_brume, _shipObject.Pos);
        }



        Brume.Brume _brume = null;
        private float _fShootCoolDown = 800f;

        FireEffect _reactorEffect = null;
        private float _fMoveSpeed = 250f;

        BrumeLightedObject _shipObject = null;

    }
}
