using System;
using System.Collections.Generic;
using System.Text;
using Brume;
using TestBrume.Entities;

namespace TestBrume
{
    class ShootsManager
    {
        #region singleton
        private static ShootsManager singleton = null;

        public static ShootsManager GetInstance()
        {
            if (singleton == null)
                singleton = new ShootsManager();

            return singleton;
        }
        #endregion


        public static void AddShoot(Shoot pShoot)
        {
            GetInstance()._lstShoots.Add(pShoot);
        }

        public static void Update(Brume.Brume pBrume,float pElapsedTime)
        {
            foreach (Shoot shoot in GetInstance()._lstShoots)
            {
                if (shoot.Pos.X < -60)
                {
                    shoot.Remove();
                    
                }

                foreach (Ennemy ennemy in EnnemiesManager.Ennemies)
                {
                    if ((ennemy.X - shoot.Pos.X) * (ennemy.X - shoot.Pos.X) + (ennemy.Z - shoot.Pos.Z) * (ennemy.Z - shoot.Pos.Z) < 4)
                    {
                        shoot.Remove();
                        ennemy.Remove();
                    }
                }
            }

            foreach (Shoot shoot in GetInstance()._lstShootsToRemove)
            {
                GetInstance()._lstShoots.Remove(shoot);
            }

            GetInstance()._lstShootsToRemove.Clear();

        }

        public static void Remove(Shoot pShoot)
        {
            GetInstance()._lstShootsToRemove.Add(pShoot);
        }



        List<Shoot> _lstShootsToRemove = new List<Shoot>();
        List<Shoot> _lstShoots = new List<Shoot>();

    }
}
