using System;
using System.Collections.Generic;
using System.Text;
using Brume;

namespace TestBrume
{
    class SpaceCamera : BrumeCamera
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpaceCamera"/> class.
        /// </summary>
        /// <param name="pBrume">The p brume.</param>
        /// <param name="pName">Name of the p.</param>
        public SpaceCamera(Brume.Brume pBrume, string pName)
            : base(pBrume, pName)
        {
            BrumeVector dir = new BrumeVector(-1f, -0.4f, 0.0f);
            dir.Normalize();

            BrumeVector up = new BrumeVector(0.0f, 1.0f, 0.0f);
            up.Normalize();

            Pos = new BrumeVector(15.0f, 10.0f, 0f);
            Orient(dir, up);

            

            ChangeNearFarDistances(0.05f, 1000.0f);
           
        }


    }
}
