float4x4 worldViewProj;	
float4x4 world;	
float4 cameraPos; 


texture EnvironmentCubeMap
<
    string ResourceType = "CUBE";
>;
samplerCUBE EnvironmentCubeMapSampler = sampler_state
{
   Texture = <EnvironmentCubeMap>;
   MinFilter = Linear;
   MagFilter = Linear;
   MipFilter = Linear;
    // AddressU  = Clamp;
   //AddressV  = Clamp;
   //AddressW  = Clamp; 
};


struct VS_OUTPUT
{
  float4 Pos  : POSITION;
	float3 Reflect: TEXCOORD;    
};

VS_OUTPUT VS(float4 Pos : POSITION, float3 Normal : NORMAL)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;      
    Out.Pos = mul(Pos, worldViewProj);	// transform Position
    float3 Norm = normalize(mul(Normal, world));
   
    // get a vector toward the camera/eye -> V
    float3 PosWorld  = normalize(mul(Pos, world));
    float3 Incident = normalize(PosWorld  - cameraPos);
    
	  // Reflection Vector for cube map: R = I - 2*N * (I.N)
	  Out.Reflect = reflect(Incident, Norm);
    //	Out.Reflect = Incident - 2 * Norm * dot(Incident, Norm);
	
   return Out;
}

float4 PS(float3 Ref : TEXCOORD) : COLOR
{
	return texCUBE(EnvironmentCubeMapSampler, Ref);    
}

technique StaticEnvironment
{
    pass P0
    {         
        Sampler[0] = (EnvironmentCubeMapSampler);		
    
        // compile shaders
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
